;
; 	      KCam
;          KCam
;      - MaxStepper ( )   
;    18- ,      
;       .
;
; Version 1.0 - 14/11/08 - azmaster@mail.ru  http://azmaster.narod.ru
; 
;    ...
; 1B-0A-00DAC0-FFFFFFFF-FFFFFFFF-00002710-FFFFFFFF-0C80-00D700-0003C0-03-0000FF03-1511
; 1B - Escape ,  .
; 0A -       .
; 3  -       ,
;                 .
; 4  -    ,        X.
; 4  -    ,        Y.
; 4  -    ,        Z.
; 4  -    ,        A.
; 2  -     .
; 3  -  .
; 3  -  .
; 1   -   .
; 4  - ( )
; 2  -   .

	TITLE	"MaxStepper.asm"
	LIST	P=18F4520
	RADIX	DEC
	include	<p18f4520.inc>
	errorlevel -302

#define	freq		.40000000	;  * PLL
#define	baud		.115200		; RS232 baud
#define	MaxFlash	0x7FFF		; bytes / 2 = words
#define	MaxRAM		0x5FF		; bytes

	CONFIG OSC=HSPLL,PWRT=ON,WDT=OFF,MCLRE=OFF,LVP=OFF,DEBUG=OFF

;	CONFIG	OSCS=OFF, OSC=HSPLL, BOR=ON, BORV=42, PWRT=ON, WDT=OFF, WDTPS = 8
;	CONFIG	CCP2MUX=ON, DEBUG=OFF, LVP=OFF, STVR=ON

;=========================================================================
;	:
;				  ~~~~~U~~~~~
;	RE3	MCLR/VPP 	-|1        40|- 	RB7	Z - Limit 2
;	RA0		 	-|2        39|- 	RB6	Y - Limit 2
;	RA1		 	-|3        38|- 	RB5	X - Limit 2
;	RA2	Flood	 	-|4        37|- 	RB4	Z - Limit 1
;	RA3	Mist	 	-|5        36|- 	RB3	Y - Limit 1
;	RA4	ERROR Lamp ^	-|6        35|- 	RB2	X - Limit 1
;	RA5	Drive - ZA	-|7        34|- 	RB1	Input1
;	RE0	Drive - ZA'	-|8        33|- 	RB0	E-STOP
;	RE1	Drive - ZB	-|9        32|- 	VCC
;	RE2	Drive - ZB'	-|10       31|- 	GND
;	VCC		 	-|11       30|- 	RD7	Drive - YB'
;	GND		 	-|12       29|- 	RD6	Drive - YB
;	CLKIN		 	-|13       28|- 	RD5	Drive - YA'
;	CLKOUT		 	-|14       27|- 	RD4	Drive - YA
;	RC0	CW	 	-|15       26|- 	RC7	RS232_RX
;	RC1	PWM2	 	-|16       25|- 	RC6	RS232_TX
;	RC2	PWM1		-|17       24|- 	RC5	CCW
;	RC3	i2c_SCL 	-|18       23|- 	RC4	i2c_SDA
;	RD0	Drive - XA	-|19       22|- 	RD3	Drive - XB'
;	RD1	Drive - XA'	-|20       21|- 	RD2	Drive - XB
; 				  ~~~~~~~~~~~
;=========================================================================

; **********   ************
#define		FloodOut	PORTA,2		; Coolant Fluid
#define		MistOut		PORTA,3		; Vacuum Cleaner
#define		ErrorLamp	PORTA,4		; Error Lamp (Open collector)
#define		Drive_ZA	PORTA,5		; Drive - ZA

#define		Drive_ZA_	PORTE,0		; Drive - ZA'
#define		Drive_ZB	PORTE,1		; Drive - ZB
#define		Drive_ZB_	PORTE,2		; Drive - ZB'

#define		E_STOP		PORTB,0		; E-STOP
#define		Input1		PORTB,1		; Input-1
#define		XLimit_1	PORTB,2		; X - Limit
#define		YLimit_1	PORTB,3		; Y - Limit
#define		ZLimit_1	PORTB,4		; Z - Limit
#define		XLimit_2	PORTB,5		; X - Limit
#define		YLimit_2	PORTB,6		; Y - Limit
#define		ZLimit_2	PORTB,7		; Z - Limit

#define		CW		PORTC,0		; CW
#define		PWM2		PORTC,1		; PWM2
#define		PWM1		PORTC,2		; PWM1
#define		i2c_SCL		PORTC,3		; i2c_SCL
#define		i2c_SDA		PORTC,4		; i2c_SDA
#define		CCW		PORTC,5		; CCW
#define		RS232_TX	PORTC,6		; RS232 TX
#define		RS232_RX	PORTC,7		; RS232 RX

#define		Drive_XA	PORTD,0		; Drive - XA
#define		Drive_XA_	PORTD,1		; Drive - XA'
#define		Drive_XB	PORTD,2		; Drive - XB
#define		Drive_XB_	PORTD,3		; Drive - XB'
#define		Drive_YA	PORTD,4		; Drive - YA
#define		Drive_YA_	PORTD,5		; Drive - YA'
#define		Drive_YB	PORTD,6		; Drive - YB
#define		Drive_YB_	PORTD,7		; Drive - YB'

; **********   ************
INITA		EQU	B'00000011'
DataA		EQU	B'00000011'

INITB		EQU	B'11111111'
DataB		EQU	B'11111111'

INITC		EQU	B'11011000'
DataC		EQU	B'11011000'

INITD		EQU	B'00000000'
DataD		EQU	B'00000000'

INITE		EQU	B'00000000'
DataE		EQU	B'00000000'

; *****   *****

	cblock 0x000

	Flags1,Flags2,Flags3

	CSH_In_Reg,CSL_In_Reg
	CSH_Out_Reg,CSL_Out_Reg

	NumByteToPrint
	BufByte
	Command

	XStepH,XStepM,XStepL
	YStepH,YStepM,YStepL
	ZStepH,ZStepM,ZStepL
	AStepH,AStepM,AStepL
				; RS232 / USART
			;  RX
	CharBufPos			;     
	NewCharRX			;   
	CurCmdLine			;   
	RXBufferLines			;   
	RXBufPosStart,RXBufPosEnd	;   
			;  TX
	CurrentChar			;  
	NextCharTX			;    
	TXBufPosStart,TXBufPosEnd	;    TX

	TempReg

	Limits
	Inputs
	Relays

	JRDH,JRDL,SRR

	FeedRateH,FeedRateL

	HzH,HzL,SHzH,SHzL
	Axis

	ReadyReg,MaskReg

	endc
	cblock 0x041

	CByte1				; Reg 0x41
	CByte2				; Reg 0x42

	DirByte
	BuffDiff

	MaxStepH,MaxStepM,MaxStepL
	XSkipU,XSkipH,XSkipM,XSkipL
	YSkipU,YSkipH,YSkipM,YSkipL
	ZSkipU,ZSkipH,ZSkipM,ZSkipL
	ASkipU,ASkipH,ASkipM,ASkipL

	RUSH,RUSM,RUSL
	RDSH,RDSM,RDSL

	Reg1,Reg2,Reg3,Reg4

	CmdRegH,CmdRegL

	endc
	cblock 0x088

	WDog				; Reg 0x88

	SkpXU,SkpXH,SkpXM,SkpXL
	SkpYU,SkpYH,SkpYM,SkpYL
	SkpZU,SkpZH,SkpZM,SkpZL
	SkpAU,SkpAH,SkpAM,SkpAL

	OutBufStart:.102,OutBufEnd

	endc
	cblock 0x100

	RXBuffer	; 0x5FF-0x100=.1279/36=35(max.)

	endc

; ---------

;;;;;;; Macro definitions ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;---------------------------------------------------------------
;
; *****   *****
;
VerNumH_Con	EQU	.04
VerNumM_Con	EQU	.00
VerNumL_Con	EQU	.04
VerDatU_Con	EQU	.02
VerDatH_Con	EQU	.12
VerDatM_Con	EQU	.20
VerDatL_Con	EQU	.08

RXBufLine_Con	EQU	.40	;     
RXBufByte_Con	EQU	.36	;      
;
;---------------------------------------------------------------
;	**********    *************
;---------------------------------------------------------------

; ********** Micro Macro ************
#define		if_Zero		btfss STATUS,Z	; If Zero
#define		if_No_Zero	btfsc STATUS,Z	; If no Zero
#define		if_Carrier	btfsc STATUS,C	; If Carier
#define		if_No_Carrier	btfss STATUS,C	; If no Carier
;---------------------------------------------------------------

; -------------- Flags -------------
#define		Pause_Fl	Flags1,0	;  ''
#define		Escape_Fl	Flags1,1	;  ''
#define		Command_Fl	Flags1,2	;  ''
#define		CS1_Fl		Flags1,3	;  ''
#define		CS2_Fl		Flags1,4	;  ''
#define		End_Data_Fl	Flags1,5	;  ''
#define		StepReady_Fl	Flags1,6	;  ''
;---------------------------------------------------------------
#define		TXBuffer_Fl	Flags2,0	;  ' TX  '
#define		RXBuffer_Fl	Flags2,1	;  ' RX  '
#define		NewCmd_Fl	Flags2,2	;  ' '
#define		Reception_Fl	Flags2,3	;  ''
#define		MotionCmd_Fl	Flags2,4	;  ' '
;---------------------------------------------------------------
#define		AxisX_Fl	Axis,0		;  ''
#define		AxisY_Fl	Axis,1		;  ''
#define		AxisZ_Fl	Axis,2		;  ''
#define		AxisA_Fl	Axis,3		;  ''
;---------------------------------------------------------------

;_________________________________________________________________________________
;_________________________________________________________________________________

;******************************************************
;*******   ~~	Begin	Main	Program   ~~	*******
;******************************************************

;---------------------------------------------------------------
		ORG	0x0000
;---------------------------------------------------------------
RESET_Vector

		 GOTO	Start_Prog			; GOTO	BootLoader

;---------------------------------------------------------------
		ORG	0x0008
;---------------------------------------------------------------

		 GOTO	HighInterruptVector

;---------------------------------------------------------------
		ORG	0x0018
;---------------------------------------------------------------
LowInterruptVector
		 RESET
;_________________________________________________________________________________
HighInterruptVector
TMR1Int
		BTFSS	INTCON,T0IF	; If TMR0
		 BRA	IntErr

		BCF	INTCON,T0IF		;    TMR0

		BTFSS	MotionCmd_Fl	;   !
		 RETFIE 1		; ...

		BTFSC	Pause_Fl	;   !
		 RETFIE 1		; ...

	;    -------------------
Test_X
		BTFSS	AxisX_Fl
		 BRA	Test_Y

		DECF	SkpXM,F
		if_No_Zero
		 BRA	Tst_X
		if_Carrier
		 BRA	Test_Y
		DECF	SkpXH,F
		if_Carrier
		 BRA	Test_Y
		DECF	SkpXU,F
		 BRA	Test_Y
Tst_X
		MOVF	SkpXH,W
		IORWF	SkpXU,W
		if_Zero
		 BRA	Test_Y

		BTFSS	StepReady_Fl
		 BSF	MaskReg,0

		BSF	ReadyReg,0

		MOVFF	XSkipU,SkpXU
		MOVFF	XSkipH,SkpXH
		MOVFF	XSkipM,SkpXM
		MOVF	XSkipL,W
		ADDWF	SkpXL,F
		if_No_Carrier
		 BRA	Test_Y
		INCFSZ	SkpXM,F
		 BRA	Test_Y
		INFSNZ	SkpXH,F
		 INCF	SkpXU,F

	;    -------------------
Test_Y
		BTFSS	AxisY_Fl
		 BRA	Test_Z

		DECF	SkpYM,F
		if_No_Zero
		 BRA	Tst_Y
		if_Carrier
		 BRA	Test_Z
		DECF	SkpYH,F
		if_Carrier
		 BRA	Test_Z
		DECF	SkpYU,F
		 BRA	Test_Z
Tst_Y
		MOVF	SkpYH,W
		IORWF	SkpYU,W
		if_Zero
		 BRA	Test_Z

		BTFSS	StepReady_Fl
		 BSF	MaskReg,1

		BSF	ReadyReg,1

		MOVFF	YSkipU,SkpYU
		MOVFF	YSkipH,SkpYH
		MOVFF	YSkipM,SkpYM
		MOVF	YSkipL,W
		ADDWF	SkpYL,F
		if_No_Carrier
		 BRA	Test_Z
		INCFSZ	SkpYM,F
		 BRA	Test_Z
		INFSNZ	SkpYH,F
		 INCF	SkpYU,F

	;    -------------------
Test_Z
		BTFSS	AxisZ_Fl
		 BRA	Test_A

		DECF	SkpZM,F
		if_No_Zero
		 BRA	Tst_Z
		if_Carrier
		 BRA	Test_A
		DECF	SkpZH,F
		if_Carrier
		 BRA	Test_A
		DECF	SkpZU,F
		 BRA	Test_A
Tst_Z
		MOVF	SkpZH,W
		IORWF	SkpZU,W
		if_Zero
		 BRA	Test_A

		BTFSS	StepReady_Fl
		 BSF	MaskReg,2

		BSF	ReadyReg,2

		MOVFF	ZSkipU,SkpZU
		MOVFF	ZSkipH,SkpZH
		MOVFF	ZSkipM,SkpZM
		MOVF	ZSkipL,W
		ADDWF	SkpZL,F
		if_No_Carrier
		 BRA	Test_A
		INCFSZ	SkpZM,F
		 BRA	Test_A
		INFSNZ	SkpZH,F
		 INCF	SkpZU,F

	;    -------------------
Test_A
		BTFSS	AxisA_Fl
		 BRA	Test_All

		DECF	SkpAM,F
		if_No_Zero
		 BRA	Tst_A
		if_Carrier
		 BRA	Test_All
		DECF	SkpAH,F
		if_Carrier
		 BRA	Test_All
		DECF	SkpAU,F
		 BRA	Test_All
Tst_A
		MOVF	SkpAH,W
		IORWF	SkpAU,W
		if_Zero
		 BRA	Test_All

		BTFSS	StepReady_Fl
		 BSF	MaskReg,3

		BSF	ReadyReg,3

		MOVFF	ASkipU,SkpAU
		MOVFF	ASkipH,SkpAH
		MOVFF	ASkipM,SkpAM
		MOVF	ASkipL,W
		ADDWF	SkpAL,F
		if_No_Carrier
		 BRA	Test_All
		INCFSZ	SkpAM,F
		 BRA	Test_All
		INFSNZ	SkpAH,F
		 INCF	SkpAU,F

	;    -------------------
Test_All
		MOVF	ReadyReg,W
		if_No_Zero
		 RETFIE 1		; ...

		BSF	StepReady_Fl		;   - ''

		MOVF	ReadyReg,W
		ANDWF	MaskReg,W
		if_No_Zero
		 BRA	X_Motion

		DECF	MaxStepL,F
		if_Carrier
		 BRA	X_Motion
		DECF	MaxStepM,F
		if_Carrier
		 BRA	X_Motion
		DECF	MaxStepH,F
		if_Carrier
		 BRA	X_Motion

		BCF	StepReady_Fl		;   - ''
		CLRF	MaskReg
		CLRF	ReadyReg
		BCF	NewCmd_Fl	   ;   ' '
		BCF	MotionCmd_Fl	   ;   ' '

		 RETFIE 1		; ...

	;    -------------------
X_Motion
		BTFSS	ReadyReg,0
		 BRA	Y_Motion

		BTFSC	DirByte,0
		 BRA	X_Dec
X_Inc
		INCFSZ	XStepL,F
		 BRA	Y_Motion
		INCFSZ	XStepM,F
		 BRA	Y_Motion
		INCF	XStepH,F
		 BRA	Y_Motion
X_Dec
		DECF	XStepL,F
		if_Carrier
		 BRA	Y_Motion
		DECF	XStepM,F
		if_No_Carrier
		 DECF	XStepH,F

	;    -------------------
Y_Motion
		BTFSS	ReadyReg,1
		 BRA	Z_Motion

		BTFSC	DirByte,1
		 BRA	Y_Dec
Y_Inc
		INCFSZ	YStepL,F
		 BRA	Z_Motion
		INCFSZ	YStepM,F
		 BRA	Z_Motion
		INCF	YStepH,F
		 BRA	Z_Motion
Y_Dec
		DECF	YStepL,F
		if_Carrier
		 BRA	Z_Motion
		DECF	YStepM,F
		if_No_Carrier
		 DECF	YStepH,F

	;    -------------------
Z_Motion
		BTFSS	ReadyReg,2
		 BRA	A_Motion

		BTFSC	DirByte,2
		 BRA	Z_Dec
Z_Inc
		INCFSZ	ZStepL,F
		 BRA	A_Motion
		INCFSZ	ZStepM,F
		 BRA	A_Motion
		INCF	ZStepH,F
		 BRA	A_Motion

		BRA	A_Motion
Z_Dec
		DECF	ZStepL,F
		if_Carrier
		 BRA	A_Motion
		DECF	ZStepM,F
		if_No_Carrier
		 DECF	ZStepH,F

	;    -------------------
A_Motion
		BTFSS	ReadyReg,3
		 BRA	End_Motion

		BTFSC	DirByte,3
		 BRA	A_Dec
A_Inc
		INCFSZ	AStepL,F
		 BRA	End_Motion
		INCFSZ	AStepM,F
		 BRA	End_Motion
		INCF	AStepH,F
		 BRA	End_Motion

		BRA	End_Motion
A_Dec
		DECF	AStepL,F
		if_Carrier
		 BRA	End_Motion
		DECF	AStepM,F
		if_No_Carrier
		 DECF	AStepH,F

	;    -------------------
End_Motion
		CLRF	ReadyReg
IntExit
		 RETFIE 1		; ...
;_________________________________________________________________________________
IntErr
		CLRF	RCON
		CLRF	INTCON
		CLRF	INTCON2
		CLRF	INTCON3
		CLRF	PIR1
		CLRF	PIR2
		CLRF	PIE1
		CLRF	PIE2
		CLRF	IPR1
		CLRF	IPR2
		 RETFIE	1		; ...
;_________________________________________________________________________________


;******************************************************
;*******   ~~	Start	Program   ~~	*******
;******************************************************

Start_Prog
		CLRF	INTCON		;reset All Interrupts
	;	CLRF	RCON		;reset All Interrupts
		CLRF	PCLATH		;reset PCLATH for Page0 operation
		CLRF	STATUS		;reset STATUS for Bank0 operation
		CLRF	PIE1
		CLRF	PIE2
		CLRF	T0CON
		CLRF	T1CON
		CLRF	T2CON
		CLRF	T3CON
	;    -------------------

		LFSR	FSR0,0
ClearRam
		CLRF	INDF0
		INCFSZ	FSR0L
		 BRA	ClearRam

	;    -------------------
InitPort
		MOVLW	DataA
		MOVWF	PORTA
		MOVLW	DataB
		MOVWF	PORTB
		MOVLW	DataC
		MOVWF	PORTC
		MOVLW	DataD
		MOVWF	PORTD
		MOVLW	DataE
		MOVWF	PORTE

		MOVLW	INITA
		MOVWF	TRISA
		MOVLW	INITB
		MOVWF	TRISB
		MOVLW	INITC
		MOVWF	TRISC
		MOVLW	INITD
		MOVWF	TRISD
		MOVLW	INITE
		MOVWF	TRISE
InitUSART
		BCF	TRISC,RC6	;  6   ,   ( TX  USART)
		CLRF	RCSTA		;  USART

		MOVLW	.86		; freq/baud/.64-1
		MOVWF	SPBRG		;   115200
		MOVLW	b'00100100' 	;TXEN=1; BRGH=0;  (SYNC=0); 8-  (TX9=0)        
		MOVWF	TXSTA
		MOVLW	b'10010000'	; SPEN=1; CREN=1; ADDEN=0; RX9=0
		MOVWF	RCSTA
		MOVLW	b'01001000'	; BRG16=1
		MOVWF	BAUDCON
	;	bsf	PIE1,TXIE	; enable int on transmit
	;	BSF	PIE1,RCIE	; enable int on receive

		MOVLW	(OutBufEnd - OutBufStart) + 1  ; !   TX
		MOVWF	TXBufPosStart
		MOVWF	TXBufPosEnd
InitADC
		MOVLW	b'10000001'	; ADCS1,ADCS0,CHS2,CHS1,CHS0,GO/DONE,0,ADON
		MOVWF	ADCON0
		MOVLW	b'00001110'	; ADFM,ADCS2,0,0,PCFG3:PCFG0
		MOVWF	ADCON1

	;    -------------------

		CLRF	TMR0L

		MOVLW   B'00000000'
		MOVWF	INTCON2

		MOVLW   B'11011111'
		MOVWF	T0CON
		BSF	INTCON,T0IE		;    TMR0

		bsf	INTCON, PEIE		;    
		bsf	INTCON, GIE		;   

		BSF	WDTCON,SWDTEN		; WDT Enable

	;    -------------------
		BSF	ErrorLamp	;  !
	;    -------------------

		MOVLW	.18
		MOVWF	WDog

		MOVLW	0x00
		MOVWF	YStepH
		MOVWF	XStepH
		MOVWF	ZStepH
		MOVWF	AStepH

		MOVLW	0x00
		MOVWF	XStepM
		MOVWF	YStepM
		MOVWF	ZStepM
		MOVWF	AStepM

		MOVLW	0x00
		MOVWF	XStepL
		MOVWF	YStepL
		MOVWF	ZStepL
		MOVWF	AStepL

		MOVLW	RXBufLine_Con - 1
		MOVWF	BuffDiff		;   !

		BRA	VersionInfo
;_________________________________________________________________________________
;_________________________________________________________________________________

MAIN
		CLRWDT

	;    -------------------
		 CALL	USER_Prog
	;    -------------------

		BTFSC	Reception_Fl
		 BRA	Reception

		BTFSC	PIR1,RCIF	; while(!RCIF)
		 BRA	ReadFifo

		BTFSC	NewCmd_Fl	;   ?
		 BRA	MAIN

		BTFSC	RXBuffer_Fl	;  ?
		 BRA	BufCmdRead

		  BRA	MAIN
;-----------------------------------------------------------------------------------
Reception
		BCF	Reception_Fl

		CLRF	CSL_Out_Reg
		CLRF	CSH_Out_Reg

		MOVLW	0x1B
		CALL	CharToPrintCS

		MOVF	Command,W
		CALL	CharToPrintCS

		MOVLW	upper	PutBraTab
		MOVWF	PCLATU
		MOVLW	high	PutBraTab
		MOVWF	PCLATH
		MOVLW	.08
		SUBWF	Command,W
		RLNCF	WREG,F
		ADDLW	low	PutBraTab
		if_Carrier
		 INCF	PCLATH
		if_Carrier
		 INCF	PCLATU
		MOVWF	PCL
PutBraTab
		 BRA	Put_08
		 BRA	Put_09
		 BRA	Put_0A
		 BRA	Put_0B
		 BRA	TypeCS
		 BRA	Put_0D
		 BRA	Put_0E
		 BRA	Put_0F
		 BRA	Put_10
		 BRA	Put_11
		 BRA	TypeCS
		 BRA	Put_13
		 BRA	TypeCS
		 BRA	TypeCS
		 BRA	TypeCS
		 BRA	TypeCS
		 BRA	TypeCS
		 BRA	TypeCS
		 BRA	TypeCS
		 BRA	TypeCS
		 BRA	Put_1C
		 BRA	Put_1D
		 BRA	Put_1E
		 BRA	Put_1F
		 BRA	Put_20
;_________________________________________________________________________________

;-----------------------------------------------------------------------------------
Put_08
		MOVLW	VerNumH_Con
		CALL	CharToPrintCS
		MOVLW	VerNumM_Con
		CALL	CharToPrintCS
		MOVLW	VerNumL_Con
		CALL	CharToPrintCS
		MOVLW	VerDatU_Con
		CALL	CharToPrintCS
		MOVLW	VerDatH_Con
		CALL	CharToPrintCS
		MOVLW	VerDatM_Con
		CALL	CharToPrintCS
		MOVLW	VerDatL_Con
		CALL	CharToPrintCS
		 BRA	TypeCS
	;    -------------------------------
Put_09
		MOVLW	0x2A
		CALL	CharToPrintCS
		MOVLW	0xDB
		CALL	CharToPrintCS
		MOVLW	0x01
		CALL	CharToPrintCS
		 BRA	TypeCS
	;    -------------------------------
Put_0A
		DECF	BuffDiff,W
		CALL	CharToPrintCS
		 BRA	TypeCS
	;    -------------------------------
Put_0B
		MOVF	XStepH,W	; XSTEP1
		CALL	CharToPrintCS
		MOVF	XStepM,W	; XSTEP2
		CALL	CharToPrintCS
		MOVF	XStepL,W	; XSTEP3
		CALL	CharToPrintCS
		MOVF	YStepH,W	; YSTEP1
		CALL	CharToPrintCS
		MOVF	YStepM,W	; YSTEP2
		CALL	CharToPrintCS
		MOVF	YStepL,W	; YSTEP3
		CALL	CharToPrintCS
		MOVF	ZStepH,W	; ZSTEP1
		CALL	CharToPrintCS
		MOVF	ZStepM,W	; ZSTEP2
		CALL	CharToPrintCS
		MOVF	ZStepL,W	; ZSTEP3
		CALL	CharToPrintCS
		MOVF	AStepH,W	; ASTEP1
		CALL	CharToPrintCS
		MOVF	AStepM,W	; ASTEP2
		CALL	CharToPrintCS
		MOVF	AStepL,W	; ASTEP3
		CALL	CharToPrintCS
		MOVF	Limits,W	; LIMITS	ALIM2,ZLIM2,YLIM2,XLIM2,ALIM1,ZLIM1,YLIM1,XLIM1
		CALL	CharToPrintCS
		MOVF	Inputs,W	; INPUTS	na,na,INP1,na,na,na,na,E-STOP
		CALL	CharToPrintCS
		MOVF	Relays,W	; RELAYS	01=OUT1(CW) 02=OUT2(CCW) 03=OUT3(Mist) 04=OUT4(Flood)
		CALL	CharToPrintCS	;		05=OUT5(Aux1) 06=OUT6(PWM) 07=OUT7(Aux2)
		MOVF	HzH,W		; HZ1
		CALL	CharToPrintCS
		MOVF	HzL,W		; HZ2
		CALL	CharToPrintCS
		MOVF	CByte1,W	; CBYTE1	; ADir,ZDir,YDir,XDir,AStep,ZStep,YStep,XStep
		CALL	CharToPrintCS
		MOVF	CByte2,W	; CBYTE2	; ALimit,ZLimit,YLimit,XLimit,
		CALL	CharToPrintCS	;			AEnable,ZEnable,YEnable,XEnable

		BCF	Inputs,0	; Reset E-Stop Flag!

		 BRA	TypeCS
	;    -------------------------------
Put_0D
		MOVF	Inputs,W		; Send Inputs Status
		CALL	CharToPrintCS
		 BRA	TypeCS
	;    -------------------------------
Put_0E
		MOVF	Inputs,W		; Send Inputs Status
		CALL	CharToPrintCS
		 BRA	TypeCS
	;    -------------------------------
Put_0F
		DECF	BuffDiff,W
		CALL	CharToPrintCS
		 BRA	TypeCS
	;    -------------------------------
Put_10
		MOVF	Axis,W
		CALL	CharToPrintCS
		 BRA	TypeCS
	;    -------------------------------
Put_11
		MOVF	Axis,W
		CALL	CharToPrintCS
		 BRA	TypeCS
	;    -------------------------------
Put_13
		MOVF	POSTINC1,W	; REGADDR_H
		ADDLW	.2
		MOVWF	FSR2H
		MOVF	POSTINC1,W	; REGADDR_L
		ADDLW	.3
		MOVWF	FSR2L
		MOVF	INDF2,W
		CALL	CharToPrintCS
		 BRA	TypeCS
	;    -------------------------------
Put_1C
		MOVF	CByte1,W	; ADir,ZDir,YDir,XDir,AStep,ZStep,YStep,XStep
		CALL	CharToPrintCS
		 BRA	TypeCS
	;    -------------------------------
Put_1D
		MOVF	CByte2,W	; ALimit,ZLimit,YLimit,XLimit,AEnable,ZEnable,YEnable,XEnable
		CALL	CharToPrintCS
		 BRA	TypeCS
	;    -------------------------------
Put_1E
		MOVF	JRDH,W
		CALL	CharToPrintCS
		MOVF	JRDL,W
		CALL	CharToPrintCS
		 BRA	TypeCS
	;    -------------------------------
Put_1F
		MOVF	SRR,W
		CALL	CharToPrintCS
		 BRA	TypeCS
	;    -------------------------------
Put_20
		MOVF	FeedRateH,W
		CALL	CharToPrintCS
		MOVF	FeedRateL,W
		CALL	CharToPrintCS
		 BRA	TypeCS
;-----------------------------------------------------------------------------------
TypeCS
		MOVF	CSL_Out_Reg,W
		CALL	CharToPrint		;  CS1  USART
		MOVF	CSH_Out_Reg,W
		CALL	CharToPrint		;  CS2  USART
		 BRA	NewCmdInit
;-----------------------------------------------------------------------------------
;	***** RS232 Send W via Port *****
;--------------------------------------------
CharToPrintCS
		ADDWF	CSL_Out_Reg,F
		BTFSC	STATUS,C		; Check Summ !!!
		 INCF	CSH_Out_Reg,F
CharToPrint
		BTFSC	TXBuffer_Fl		;   
		 BRA	CheckBufTX
		BTFSS	PIR1, TXIF		;   
		 BRA	CheckBufTX
		MOVWF	TXREG			; 
		  RETURN
	;----------------------------
	;	   USART
	;----------------------------
CheckBufTX					;  !
		MOVWF	NextCharTX		; PUSH W
		MOVF	TXBufPosEnd,W		;    TX
		SUBWF	TXBufPosStart,W
		if_Zero				;   
		 BRA	WriteBufTX
		BTFSS	TXBuffer_Fl		;    ?
		 BRA	WriteBufTX
WaitBufFree					;   
	;	CALL	USER_Prog
		MOVF	NextCharTX,W		; POP W
		BTFSC	TXBuffer_Fl	;      ...
		 RCALL	WriteFifo
		  BRA	CharToPrint		;  ...
WriteBufTX
		MOVF	TXBufPosEnd,W		;    TX
		ADDLW	OutBufStart - 1	; !
		MOVWF	FSR0L
		CLRF	FSR0H
		MOVF	NextCharTX,W		;  ,  POP W
		MOVWF	INDF0
		DECFSZ	TXBufPosEnd,F
		 BRA	TxBufCycle
					;    TX
		MOVLW	(OutBufEnd - OutBufStart) + 1	; !
		MOVWF	TXBufPosEnd
TxBufCycle
		BSF	TXBuffer_Fl		;   '  '
	;	BSF	PIE1,TXIE		;   TX
		MOVF	NextCharTX,W		; POP W
		  RETURN
;-----------------------------------------------------------------------------------

		;-------------------------------
WriteFifo:	;         FIFO
		;-------------------------------

		BTFSS	PIR1,TXIF	;  FiFO 
		 RETURN

		LFSR	FSR0,OutBufStart - 1	;   
		MOVF	TXBufPosStart,W
		ADDWF	FSR0L

		MOVF	INDF0,W			;  
		MOVWF	TXREG		;   FiFO
IncTXCount
		DECFSZ	TXBufPosStart,F		;  
		 BRA	TXBufTest
					;    TX
		MOVLW	(OutBufEnd - OutBufStart) + 1	; !
		MOVWF	TXBufPosStart
TXBufTest
		MOVF	TXBufPosStart,W		;    TX
		SUBWF	TXBufPosEnd,W
		if_No_Zero				;   
		 BCF	TXBuffer_Fl
		  RETURN
;-----------------------------------------------------------------------------------
ReadFifo:				;-------------------------------
					;        FIFO
					;-------------------------------
		MOVF	CharBufPos,W
		SUBLW	RXBufByte_Con	;   ...
		if_No_Zero
		 BRA	BufError	;   !

		MOVF	RXBufPosStart,W	;    !
		MULLW	RXBufByte_Con	;   *     
		MOVF	PRODH,W
		ADDLW	high	RXBuffer	; + 0x100 ( )
		MOVWF	FSR1H
		MOVF	PRODL,W
		ADDWF	CharBufPos,W	;   
		MOVWF	FSR1L
		if_Carrier
		 INCF	FSR1H,F

		MOVF	RCREG,W		;  USART
		MOVWF	NewCharRX	;   
		MOVWF	INDF1		;   
		INCF	CharBufPos,F	;    

		;-------------------------------

		BTFSC	End_Data_Fl
		 BRA	SkipData

		DCFSNZ	BufByte,F
		 BSF	End_Data_Fl

		MOVF	NewCharRX,W
		ADDWF	CSH_In_Reg,F
		BTFSC	STATUS,C
		 INCF	CSL_In_Reg,F

		BTFSS	Escape_Fl
		 BRA	GetEscape

		BTFSS	Command_Fl
		 BRA	CheckCommand
		  BRA	MAIN
SkipData
		BTFSS	CS1_Fl
		 BRA	GetCS1

		BTFSS	CS2_Fl
		 BRA	GetCS2

		  BRA	BufError

;-----------------------------------------------------------------------------------
GetEscape					;  !
		BSF	Escape_Fl

		MOVLW	0x1B
		SUBWF	NewCharRX,W		; if F = 27
		 BZ	GoMain

		BCF	Escape_Fl

	;    -------------------------

		MOVLW	"V"		; "V"
		SUBWF	NewCharRX,W		; if F = 27
		 BZ	VersionInfo

		MOVLW	""		; ""
		SUBWF	NewCharRX,W		; if F = 27
		 BNZ	BufError

	;    -------------------------
GoToBoot
		bcf	INTCON, GIE		;   
		bcf	INTCON, PEIE		;    
		BCF	WDTCON,SWDTEN		; WDT Disable

		BCF	ErrorLamp		; Led Lamp

		 GOTO	BootLoader
;-----------------------------------------------------------------------------------
VersionInfo
		MOVLW	low VerTable
		MOVWF	TBLPTRL
		MOVLW	high VerTable
		MOVWF	TBLPTRH
		MOVLW	upper VerTable
		MOVWF	TBLPTRU
TypeVerLoop
		tblrd	*+
		MOVF	TABLAT,W
		RCALL	CharToPrintCS			;   USART
		 BNZ	TypeVerLoop
		  BRA	MAIN
;-----------------------------------------------------------------------------------
BufError
		BCF	ErrorLamp	;   '!'
NewCmdInit
		BCF	Escape_Fl
		CLRF	CharBufPos
		BCF	CS1_Fl
		BCF	CS2_Fl
		BCF	Command_Fl
		CLRF	CSL_In_Reg
		CLRF	CSH_In_Reg
		CLRF	BufByte
		BCF	End_Data_Fl
		  BRA	MAIN
;-----------------------------------------------------------------------------------
CheckCommand
		MOVF	NewCharRX,W
		MOVWF	Command
		SUBLW	.32
		BTFSS	STATUS,C
		 BRA	BufError

		MOVLW	.08
		SUBWF	Command,W
		BTFSS	STATUS,C
		 BRA	BufError

		BSF	Command_Fl

		MOVLW	upper Get_Tab
		MOVWF	TBLPTRU
		MOVLW	high Get_Tab
		MOVWF	TBLPTRH
		MOVLW	.08
		SUBWF	Command,W
		ADDLW	low Get_Tab
		MOVWF	TBLPTRL
		if_Carrier
		 INCF	TBLPTRH
		if_Carrier
		 INCF	TBLPTRU

		tblrd	*+

		MOVLW	.04
		SUBWF	TABLAT,W
		MOVWF	BufByte
		if_No_Zero
		 BSF	End_Data_Fl
GoMain
		  BRA	MAIN
;-----------------------------------------------------------------------------------
GetCS1
		BSF	CS1_Fl
		MOVF	NewCharRX,W
		SUBWF	CSH_In_Reg,W
		BNZ	BufError
		 BRA	MAIN
;-----------------------------------------------------------------------------------
GetCS2
		BSF	CS2_Fl
		MOVF	NewCharRX,W
		SUBWF	CSL_In_Reg,W
		BNZ	BufError

		BSF	ErrorLamp	;    '!
;-----------------------------------------------------------------------------------
CommandRead
		MOVF	RXBufPosStart,W	;  !
		MULLW	RXBufByte_Con	;    *     
		MOVF	PRODH,W
		ADDLW	high	RXBuffer	; + 0x100 ( )
		MOVWF	FSR1H
		MOVF	PRODL,W
		ADDLW	.1		;    , , !
		MOVWF	FSR1L
		if_Carrier
		 INCF	FSR1H,F

		MOVFF	POSTINC1,Command	;   

		MOVLW	upper	CmdTable
		MOVWF	PCLATU
		MOVLW	high	CmdTable
		MOVWF	PCLATH
		MOVLW	.08
		SUBWF	Command,W
		RLNCF	WREG,F
		ADDLW	low	CmdTable
		if_Carrier
		 INCF	PCLATH
		if_Carrier
		 INCF	PCLATU
		MOVWF	PCL
CmdTable
		 BRA	Get_08
		 BRA	Get_09
		 BRA	BufferUp	; Get_0A
		 BRA	Get_0B
		 BRA	Get_0C
		 BRA	BufferUp	; Get_0D
		 BRA	BufferUp	; Get_0E
		 BRA	Get_0F
		 BRA	BufferUp	; Get_10
		 BRA	BufferUp	; Get_11
		 BRA	Get_12
		 BRA	Get_13
		 BRA	Get_14
		 BRA	BufferUp	; Get_15
		 BRA	BufferUp	; Get_16
		 BRA	Get_17
		 BRA	Get_18
		 BRA	Get_19
		 BRA	Get_1A
		 BRA	Get_1B
		 BRA	Get_1C
		 BRA	Get_1D
		 BRA	BufferUp	; Get_1E
		 BRA	BufferUp	; Get_1F
		 BRA	BufferUp	; Get_20
		  BRA	MAIN
;-----------------------------------------------------------------------------------
RunCommand
		MOVLW	upper	GetBraTab
		MOVWF	PCLATU
		MOVLW	high	GetBraTab
		MOVWF	PCLATH
		MOVLW	.08
		SUBWF	Command,W
		RLNCF	WREG,F
		ADDLW	low	GetBraTab
		if_Carrier
		 INCF	PCLATH
		if_Carrier
		 INCF	PCLATU
		MOVWF	PCL
GetBraTab
		 BRA	Get_08
		 BRA	Get_09
		 BRA	Get_0A
		 BRA	Get_0B
		 BRA	Get_0C
		 BRA	Get_0D
		 BRA	Get_0E
		 BRA	Get_0F
		 BRA	Get_10
		 BRA	Get_11
		 BRA	Get_12
		 BRA	Get_13
		 BRA	Get_14
		 BRA	Get_15
		 BRA	Get_16
		 BRA	Get_17
		 BRA	Get_18
		 BRA	Get_19
		 BRA	Get_1A
		 BRA	Get_1B
		 BRA	Get_1C
		 BRA	Get_1D
		 BRA	Get_1E
		 BRA	Get_1F
		 BRA	Get_20
		  BRA	MAIN
;-----------------------------------------------------------------------------------
Get_Tab
		DB	.04,.04,.36,.04,.04,.05,.05,.04,.05,.05,.16,.06,.07,.04,.04,.04,.04,.04,.04,.06,.05,.05,.06,.05,.06
;-----------------------------------------------------------------------------------
Put_Tab
		DB	.11,.07,.05,.07,.04,.05,.05,.04,.05,.05,.04,.05,.04,.04,.04,.04,.04,.04,.04,.06,.05,.05,.06,.05,.06
;-----------------------------------------------------------------------------------
VerTable
	DB "CNC Controller v1.0",0x0D,0x0A,"(C)AZMaster",0x0D,0x0A,"2008",0x0D,0x0A,"(Pic18F4520)",0x0D,0x0A,0x0D,0x0A,0
;-----------------------------------------------------------------------------------
Answer						; Get Firmvare Version
		BSF	Reception_Fl
		  BRA	MAIN
	;    -------------------------------
Get_08						; Get Firmvare Version
		  BRA	Answer
	;    -------------------------------
Get_09						; Get MaxId Number
		  BRA	Answer
	;    -------------------------------
Get_0A						; Get Motion Command
		MOVFF	POSTINC1,MaxStepH	; MAXSTEP1
		MOVFF	POSTINC1,MaxStepM	; MAXSTEP2
		MOVFF	POSTINC1,MaxStepL	; MAXSTEP3
		MOVFF	POSTINC1,XSkipU		; XSKIP1
		MOVFF	XSkipU,SkpXU
		MOVFF	POSTINC1,XSkipH		; XSKIP2
		MOVFF	XSkipH,SkpXH
		MOVFF	POSTINC1,XSkipM		; XSKIP3
		MOVFF	XSkipM,SkpXM
		MOVFF	POSTINC1,XSkipL		; XSKIP4
		MOVFF	XSkipL,SkpXL
		MOVFF	POSTINC1,YSkipU		; YSKIP1
		MOVFF	YSkipU,SkpYU
		MOVFF	POSTINC1,YSkipH		; YSKIP2
		MOVFF	YSkipH,SkpYH
		MOVFF	POSTINC1,YSkipM		; YSKIP3
		MOVFF	YSkipM,SkpYM
		MOVFF	POSTINC1,YSkipL		; YSKIP4
		MOVFF	YSkipL,SkpYL
		MOVFF	POSTINC1,ZSkipU		; ZSKIP1
		MOVFF	ZSkipU,SkpZU
		MOVFF	POSTINC1,ZSkipH		; ZSKIP2
		MOVFF	ZSkipH,SkpZH
		MOVFF	POSTINC1,ZSkipM		; ZSKIP3
		MOVFF	ZSkipM,SkpZM
		MOVFF	POSTINC1,ZSkipL		; ZSKIP4
		MOVFF	ZSkipL,SkpZL
		MOVFF	POSTINC1,ASkipU		; ASKIP1
		MOVFF	ASkipU,SkpAU
		MOVFF	POSTINC1,ASkipH		; ASKIP2
		MOVFF	ASkipH,SkpAH
		MOVFF	POSTINC1,ASkipM		; ASKIP3
		MOVFF	ASkipM,SkpAM
		MOVFF	POSTINC1,ASkipL		; ASKIP4
		MOVFF	ASkipL,SkpAL
		MOVFF	POSTINC1,SHzH		; SHzH
		MOVFF	POSTINC1,SHzL		; SHzL
		MOVFF	POSTINC1,RUSH		; RUSH
		MOVFF	POSTINC1,RUSM		; RUSM
		MOVFF	POSTINC1,RUSL		; RUSL
		MOVFF	POSTINC1,RDSH		; RDSH
		MOVFF	POSTINC1,RDSM		; RDSM
		MOVFF	POSTINC1,RDSL		; RDSL
		MOVFF	POSTINC1,DirByte	; DIRBYTE

		MOVFF	POSTINC1,Reg1		; ???
		MOVFF	POSTINC1,Reg2		; ???
		MOVFF	POSTINC1,Reg3		; ???
		MOVFF	POSTINC1,Reg4		; ???

		INFSNZ	CmdRegL,F
		 INCF	CmdRegH,F
		MOVF	CmdRegL,W
		SUBLW	.7
		if_No_Zero
		 NOP

		MOVF	MaxStepM,W
		IORWF	MaxStepH,W
		IORWF	MaxStepL,W
		if_No_Zero
		  BRA	Answer

		CLRF	Axis
		BTFSS	XSkipU,7
		 BSF	Axis,0
		BTFSS	YSkipU,7
		 BSF	Axis,1
		BTFSS	ZSkipU,7
		 BSF	Axis,2
		BTFSS	ASkipU,7
		 BSF	Axis,3

		BSF	NewCmd_Fl	;   ' '
		BSF	MotionCmd_Fl	;   !

		  BRA	Answer
	;    -------------------------------
Get_0B						; Get Current Position Data
		  BRA	Answer
	;    -------------------------------
Get_0C						; Clear All Motion Commands in Buffer
		BCF	RXBuffer_Fl		;  !
		CLRF	RXBufPosStart
		CLRF	RXBufferLines
		CLRF	RXBufPosEnd
		CLRF	CurCmdLine
		 CLRF	Axis
		  BRA	Answer
	;    -------------------------------
Get_0D						; Turn a Relay Output Off
		MOVF	POSTINC1,W	
		RCALL	NumToBit
		COMF	WREG			; 01=OUT1(CW) 02=OUT2(CCW) 03=OUT3(Mist) 04=OUT4(Flood)
		ANDWF	Relays,F		; 05=OUT5(Aux1) 06=OUT6(PWM) 07=OUT7(Aux2)
		  BRA	Answer
	;    -------------------------------
Get_0E						; Turn a Relay Output On
		MOVF	POSTINC1,W	
		CALL	NumToBit
		IORWF	Relays,F
		  BRA	Answer
	;    -------------------------------
Get_0F						; Get Command Buffer Free Space
		  BRA	Answer
	;    -------------------------------
Get_10						; Disable an Axis
		MOVF	POSTINC1,W	
		RCALL	NumToBit
		COMF	WREG
		ANDWF	Axis,F
		  BRA	Answer
	;    -------------------------------
Get_11						; Enable an Axis
		MOVF	POSTINC1,W	
		CALL	NumToBit
		IORWF	Axis,F
		  BRA	Answer
	;    -------------------------------
Get_12								; Set the Curent Position
		MOVFF	POSTINC1,XStepH		; XSTEP1
		MOVFF	POSTINC1,XStepM		; XSTEP2
		MOVFF	POSTINC1,XStepL		; XSTEP3
		MOVFF	POSTINC1,YStepH		; YSTEP1
		MOVFF	POSTINC1,YStepM		; YSTEP2
		MOVFF	POSTINC1,YStepL		; YSTEP3
		MOVFF	POSTINC1,ZStepH		; ZSTEP1
		MOVFF	POSTINC1,ZStepM		; ZSTEP2
		MOVFF	POSTINC1,ZStepL		; ZSTEP3
		MOVFF	POSTINC1,AStepH		; ASTEP1
		MOVFF	POSTINC1,AStepM		; ASTEP2
		MOVFF	POSTINC1,AStepL		; ASTEP3
		  BRA	Answer
	;    -------------------------------
Get_13						; Get a Memory Register's Value (Peec)
		  BRA	Answer
	;    -------------------------------
Get_14						; Set a Memory Register's Value (Poke)						; 
		MOVFF	POSTINC1,FSR2L	
		MOVFF	POSTINC1,FSR2H	
		MOVFF	POSTINC1,INDF2	
		  BRA	Answer
	;    -------------------------------
Get_15						; Enable Axis Travel Limit Relays
		  BRA	Answer
	;    -------------------------------
Get_16						; Disable Axis Travel Limit Relays
		  BRA	Answer
	;    -------------------------------
Get_17						; Turn Axis Timer Enable Mode On
		  BRA	Answer
	;    -------------------------------
Get_18						; Turn Axis Timer Enable Mode Off
		  BRA	Answer
	;    -------------------------------
Get_19						; Pause Axis Motion
		BSF	Pause_Fl
		  BRA	Answer
	;    -------------------------------
Get_1A						; Resume Axis Motion
		BCF	Pause_Fl
		  BRA	Answer
	;    -------------------------------
Get_1B						; Intentionally ( NOT USED )
		  BRA	Answer
	;    -------------------------------
Get_1C						; Set Control Byte 1
		MOVFF	POSTINC1,CByte1	
		COMF	CByte1,F		; ADir,ZDir,YDir,XDir,AStep,ZStep,YStep,XStep
		  BRA	Answer
	;    -------------------------------
Get_1D						; Set Control Byte 2
		MOVFF	POSTINC1,CByte2	
		COMF	CByte2,F		; ALimit,ZLimit,YLimit,XLimit,AEnable,ZEnable,YEnable,XEnable
		  BRA	Answer
	;    -------------------------------
Get_1E						; Jog Ramp Down
		MOVFF	POSTINC1,JRDH	
		MOVFF	POSTINC1,JRDL	
		CLRF	MaxStepH
		MOVFF	JRDH,MaxStepM
		MOVFF	JRDL,MaxStepL
		  BRA	Answer
	;    -------------------------------
Get_1F						; Set Ramp Rate
		MOVFF	POSTINC1,SRR	
		  BRA	Answer
	;    -------------------------------
Get_20						; Set Ramp Rate
		MOVFF	POSTINC1,FeedRateH	
		MOVFF	POSTINC1,FeedRateL	
		  BRA	Answer
;-----------------------------------------------------------------------------------
NumToBit
		MOVWF	TempReg
		MOVLW	.01
LoopNTB
		DCFSNZ	TempReg,F
		 RETURN

		RLNCF	WREG
		if_Zero
		 BRA	LoopNTB
		  RETURN
;-----------------------------------------------------------------------------------
BufferUp				; Add Motion Command to Command Buffer
		MOVF	RXBufPosEnd,W		;    RX
		SUBWF	RXBufPosStart,W
		if_Zero				;   
		 GOTO	GetBuffer
		BTFSC	RXBuffer_Fl		;    ?
		 GOTO	BufError		;   ...
						;    ...
		MOVFF	RXBufPosStart,CurCmdLine	;  !
GetBuffer
		INCF	RXBufPosStart,F		;      
		MOVF	RXBufPosStart,W
		SUBLW	RXBufLine_Con		;  (max.)
		if_No_Zero
		 CLRF	RXBufPosStart

		INCF	RXBufferLines,F		;     
		MOVF	RXBufferLines,W
		SUBLW	RXBufLine_Con - 1
		MOVWF	BuffDiff		;   !

		BSF	RXBuffer_Fl		;   '  '

		 BRA	NewCmdInit
	;	  BRA	MAIN
;-----------------------------------------------------------------------------------
BufCmdRead					;    !
		MOVF	CurCmdLine,W	;  !
		MULLW	RXBufByte_Con	;    *     
		MOVF	PRODH,W
		ADDLW	high	RXBuffer	; + 0x100 ( )
		MOVWF	FSR1H
		MOVF	PRODL,W
		ADDLW	.1		;    , , !
		MOVWF	FSR1L
		if_Carrier
		 INCF	FSR1H,F

		MOVFF	POSTINC1,Command	;   
BufferDown
		INCF	RXBufPosEnd,F	;     !
		MOVF	RXBufPosEnd,W
		SUBLW	RXBufLine_Con
		if_No_Zero
		 CLRF	RXBufPosEnd	;    

		DCFSNZ	RXBufferLines,F
		 BCF	RXBuffer_Fl		; ' !'

		MOVF	RXBufferLines,W
		SUBLW	RXBufLine_Con - 1
		MOVWF	BuffDiff		;   !

		INCF	CurCmdLine,F
		MOVF	CurCmdLine,W
		SUBLW	RXBufLine_Con
		if_No_Zero
		 CLRF	CurCmdLine

	;	BSF	NewCmd_Fl	;   ' '

		 BRA	RunCommand
;_________________________________________________________________________________
;_________________________________________________________________________________

USER_Prog
		BTFSC	TXBuffer_Fl	;      ...
		 RCALL	WriteFifo

	;    -------------------

		BTFSC	Relays,0
		 BSF	CW
		BTFSS	Relays,0
		 BCF	CW

		BTFSC	Relays,1
		 BSF	CCW
		BTFSS	Relays,1
		 BCF	CCW

		BTFSC	E_STOP
		 BSF	Inputs,0	; Set E-Stop Flag!

		BTFSC	Input1
		 BCF	Inputs,5
		BTFSS	Input1
		 BSF	Inputs,5

		CLRF	Limits

		BTFSC	XStepH,6
		 BSF	Limits,4
		BTFSC	XStepH,7
		 BSF	Limits,0

		BTFSC	YStepH,6
		 BSF	Limits,5
		BTFSC	YStepH,7
		 BSF	Limits,1

		BTFSC	ZStepH,6
		 BSF	Limits,6
		BTFSC	ZStepH,7
		 BSF	Limits,2

		BTFSC	AStepH,6
		 BSF	Limits,7
		BTFSC	AStepH,7
		 BSF	Limits,3

	;	MOVF	Limits,W
	;	if_Zero
	;	 BRA	ClrAllMotion

	;    -------------------

		BTFSS	Inputs,0
		  RETURN

	;	BSF	ErrorLamp	;    '!

	;    -------------------
ClrAllMotion
		BCF	RXBuffer_Fl		;  !
		CLRF	RXBufPosStart
		CLRF	RXBufferLines
		CLRF	RXBufPosEnd
		CLRF	CurCmdLine
		 CLRF	Axis
		  RETURN
;______________________________________________________________________________________________
;______________________________________________________________________________________________

End_Programm

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;    Tiny Boot Loader - http://www.etc.ugal.ro/cchiculita/software/picbootloader.htm
;----------------------------------------------------------------------------------------------

xtal EQU 40000000		; you may want to change: _XT_OSC_1H  _HS_OSC_1H  _HSPLL_OSC_1H
baud EQU 115200			; standard TinyBld baud rates: 115200 or 19200

#define max_flash 0x8000
#define first_address max_flash-200		;100 words

	cblock 0
	crc
	i
	cnt1
	cnt2
	cnt3
	counter_hi
	counter_lo
	flag
	endc

	cblock 0x10
	buffer:64
	dummy4crc
	endc

;---------------------------------------------------------------
	ORG	first_address		;space to deposit first 4 instr. of user prog.
;---------------------------------------------------------------

BootLoader

;view with TabSize=4
;&&&&&&&&&&&&&&&&&&&&&&&   START     &&&&&&&&&&&&&&&&&&&&&&
;----------------------  Bootloader  ----------------------
;PC_flash:	0xC1	U		H	L	x  ...  <64 bytes>   ...  crc	
;PC_eeprom:	0xC1	0x40		EEADR	EEDATA	0	crc					
;PC_cfg		0xC1	U OR 0x80	H	L	1	byte	crc
;PIC_response:	type `K`
							;init serial port
	;	MOVLW	freq/baud/.64-1
	;	MOVWF	SPBRG		;  
	;	MOVLW	0x20          
	;	MOVWF	TXSTA		;TXEN=1; BRGH=0;  (SYNC=0); 8-  (TX9=0)
	;	MOVLW	0x90
	;	MOVWF	RCSTA		;SPEN=1; CREN=1; ADDEN=0; RX9=0
					;wait for computer
		rcall	Receive			
		sublw	0xC1		;Expect C1h
		 bnz	way_to_exit
MainLoop
		BTFSS	PIR1,TXIF	;  FiFO 
		 BRA	MainLoop

		MOVLW	'K'		; "-Everything OK, ready and waiting."
		MOVWF	TXREG
mainl
		clrf	crc
		rcall	Receive		;Upper
		movwf	TBLPTRU
		movwf	flag		;(for EEPROM and CFG cases)
		rcall	Receive		;Hi
		movwf	TBLPTRH
		movwf	EEADR		;(for EEPROM case)
		rcall	Receive		;Lo
		movwf	TBLPTRL
		movwf	EEDATA		;(for EEPROM case)

		rcall	Receive		;count
		movwf	i
		incf	i
		lfsr	FSR0, (buffer-1)
rcvoct					;read 64+1 bytes
		movwf	TABLAT		;prepare for cfg; => store byte before crc
		rcall	Receive
		movwf	PREINC0
		decfsz	i
		 bra	rcvoct
	
		tstfsz	crc		;check crc
		 bra	ziieroare
		btfss	flag,6		;is EEPROM data?
		 bra	noeeprom
		movlw	b'00000100'	;Setup eeprom
		rcall	Write
		 bra	waitwre
noeeprom
		btfss	flag,7		;is CFG data?
		 bra	noconfig
		tblwt*			;write TABLAT(byte before crc) to TBLPTR***
		movlw	b'11000100'	;Setup cfg
		rcall	Write
		 bra	waitwre
;------------------------------------------------------------
noconfig
					;write
eraseloop
		movlw	b'10010100'	; Setup erase
		rcall	Write
		TBLRD*-			; point to adr-1
	
writebigloop	
		movlw	8		; 8groups
		movwf	counter_hi
		lfsr	FSR0,buffer
writesloop
		movlw	8		; 8bytes = 4instr
		movwf	counter_lo
writebyte
		movf	POSTINC0,w	; put 1 byte
		movwf	TABLAT
		tblwt+*
		decfsz	counter_lo
		 bra	writebyte
	
		movlw	b'10000100'	; Setup writes
		rcall	Write
		decfsz	counter_hi
		 bra	writesloop
waitwre	
		btfsc	EECON1,WR		;for eeprom writes (wait to finish write)
		 bra	waitwre		;no need: round trip time with PC bigger than 4ms
	
		bcf	EECON1,WREN	;disable writes
		 bra	MainLoop
;------------------------------------------------------------
ziieroare				;CRC failed
		MOVLW	'N'
		MOVWF	TXREG
		 bra	mainl
	  
;******** procedures ******************

Write
		movwf	EECON1
		movlw	0x55
		movwf	EECON2
		movlw	0xAA
		movwf	EECON2
		bsf	EECON1,WR	;WRITE
		nop
		 return
;------------------------------------------------------------
Receive
		movlw	xtal/2000000+1	; for 20MHz => 11 => 1second delay
		movwf	cnt1
rpt2						
		clrf	cnt2
rpt3
		clrf	cnt3
rptc
		btfss	PIR1,RCIF	;test RX
		 bra	notrcv
		movf	RCREG,w		;return read data in W
		addwf	crc,f		;compute crc
		 return
;------------------------------------------------------------
notrcv
		decfsz	cnt3
		 bra	rptc
		decfsz	cnt2
		 bra	rpt3
		decfsz	cnt1
		 bra	rpt2
;------------------------------------------------------------
way_to_exit
		 RESET

;*************************************************************
; After reset
; Do not expect the memory to be zero,
; Do not expect registers to be initialised like in catalog.

BootEnd
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	END

